=== debian/changelog ===
frama-c (20150201+sodium+dfsg-2) unstable; urgency=medium

  * frama-c package must Breaks/Replaces older frama-c-base package
    (<< 20150201+sodium+dfsg-1~) since files were moved from the
    latter to the former (Closes: #797695).
  * Do not try to install plugins on bytecode architectures since they
    are provided only on native architectures. This is needed to fix
    FTBFS on bytecode architectures.

 -- Mehdi Dogguy <mehdi@debian.org>  Tue, 01 Sep 2015 19:34:32 +0000

frama-c (20150201+sodium+dfsg-1) unstable; urgency=medium

  * New upstream release (Closes: #797473).
    - Refrech patches.
    - Drop 0004-Port-to-OCamlgraph-1.8.5.patch: Integrated upstream.
  * Bump Standards-Version to 3.9.6, no changes needed.
  * Disable DH_VERBOSE in d/rules.
  * Install GUI plugins and modules using GTK2 in frama-c package
    only (Closes: #792612).

 -- Mehdi Dogguy <mehdi@debian.org>  Mon, 31 Aug 2015 22:18:00 +0000
